<?php


namespace Factory;


use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;
use Util\Utilities;

class OqueHaDeNovo
{
    use TQuery;
    /**
     * @var EntityManager
     */
    private $entityManager;

    /**
     * OqueHaDeNovo constructor.
     * @param EntityManager $entityManager
     */
    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function findTreeGridSubject($filterAssuntoItensProductsClient)
    {
        $query = <<<SQL
            SELECT ID, PAI_ID, DSASSUNTO, IDATIVO
            FROM OM_OQA_ASSUNTO
            WHERE IDATIVO = 'S'
            $filterAssuntoItensProductsClient

SQL;
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $query);
    }

    public function findAssuntoItensProductsClient($nrParcNegocio) {
        $query = <<<SQL
        SELECT DISTINCT IA.ASSUNTO_ID as ID
            FROM OM_PRODUTO_ORG OPO
            INNER JOIN OM_PRODUTO OMP ON OPO.NRPRODUTO_ID = OMP.ID
            INNER JOIN ORGANIZACAO ORG ON ORG.NRORG = OPO.NRORG_ID
            INNER JOIN PRODUCT PRO ON PRO.ID = OMP.NREXTERNAL_PRODUCT_ID
            INNER JOIN PROJECT PRJ ON PRJ.ID = PRO.PROJECT_ID AND PRODUCT_TYPE = 'C'
            INNER JOIN OM_OQA_ITEM T ON T.PRODUTO_ID = OMP.ID
            INNER JOIN OM_OQA_ITEM_ASSUNTO IA ON T.ID = IA.ITEM_ID
        WHERE ORG.NRPARCNEGOCIO = $nrParcNegocio
SQL;
        $result =  $this->entityManager->getConnection()->fetchAll($query);
        return Utilities::getArrayFromAssociativeArray($result);
    }

    public function findProductsClient($nrParcNegocio, $assuntoIdString) {
        $query = <<<SQL
        SELECT DISTINCT OMP.ID
            FROM OM_PRODUTO_ORG OPO
            INNER JOIN OM_PRODUTO OMP ON OPO.NRPRODUTO_ID = OMP.ID
            INNER JOIN ORGANIZACAO ORG ON ORG.NRORG = OPO.NRORG_ID
            INNER JOIN PRODUCT PRO ON PRO.ID = OMP.NREXTERNAL_PRODUCT_ID
            INNER JOIN PROJECT PRJ ON PRJ.ID = PRO.PROJECT_ID AND PRODUCT_TYPE = 'C'
            LEFT JOIN OM_OQA_ITEM T ON T.PRODUTO_ID = OMP.ID
        WHERE ORG.NRPARCNEGOCIO = $nrParcNegocio
        $assuntoIdString
SQL;
        $result =  $this->entityManager->getConnection()->fetchAll($query);
        return Utilities::getArrayFromAssociativeArray($result);
    }

    public function findItemProduct($dtfiltroitemString, $conditionsQuery, $assuntoIdString, $nrParcNegocio)
    {
        $productsIdCliente = $this->findProductsClient($nrParcNegocio, $assuntoIdString);
        $filterProductsIdCliente = 'WHERE 1=2';
        $filterProductsIdClienteItem = 'AND 1=2';
        if (!empty($productsIdCliente)) {
            $stringValues = "('" . implode("','",$productsIdCliente) . "')";
            $filterProductsIdCliente = 'WHERE P.ID IN '. $stringValues;
            $filterProductsIdClienteItem = 'AND T.PRODUTO_ID IN '. $stringValues;
        }
        $query = <<<SQL
            SELECT * FROM (
            SELECT 'P_' || P.ID AS TREE_ID, P.NMPRODUTO AS NAME, NULL AS PARENT, NULL AS ID, P.ID AS PRODUTO_ID, NULL AS PAI_ID, 
            'Y' AS IS_PRODUCT, 'S' AS IDATIVO, NULL AS DTFILTROITEM, NULL AS FILENAME
            FROM OM_PRODUTO P
            $filterProductsIdCliente
            UNION ALL
            SELECT 'T_' || T.ID AS  TREE_ID, T.DSASSUNTO AS NAME, NVL2(TO_CHAR(T.PAI_ID),'T_' || T.PAI_ID, 'P_' || T.PRODUTO_ID) AS PARENT,
            T.ID, T.PRODUTO_ID, T.PAI_ID, 'N' AS IS_PRODUCT, T.IDATIVO, T.DTFILTROITEM, T.FILENAME
            FROM OM_OQA_ITEM T
            WHERE 1=1 
            $filterProductsIdClienteItem
            $dtfiltroitemString
            $conditionsQuery
            $assuntoIdString )
            WHERE IDATIVO = 'S'
SQL;
        $result =  $this->entityManager->getConnection()->fetchAll($query);
        $total = count($result);
        $returnNext = [ 'data' => $result, 'pagination' => [ 'limit' => $total, 'page' => 1, 'total' => $total]];
        return $returnNext;
    }

}
