import { Utilities } from '@/util/Utilities';
import { LoadingService, Modal, ModalService, Text } from '@zeedhi/common';
import { Http, Metadata } from '@zeedhi/core';
import { TekGrid, TekTreeGrid, TekGridColumn } from '@zeedhi/teknisa-components-common';

export class FaturamentoController {
    public visibilidadeFrameGridPincipal: Boolean = true;

    public visibilidadeItensFrameItensValorFixo: Boolean = false;

    public visibilidadeItensFrameItensValorFixoParcela: Boolean = false;

    public visibilidadeItensFrameItensValorVariavel: Boolean = false;

    public modalMedidaVariavel!: Modal;

    public modalExibirFaturamento!: Modal;

    public modalTituloHeader!: Modal;

    public tituloHeader: String = '';

    public vrNegociado: Boolean = false;

    public route: String = '';

    public currentRow: any;

    public classModal: String = '';

    public gridHeight: String = '';

    private verificar: Boolean = true;

    public tituloHeaderCompleto: String = ' ';

    public visibilidadeAction: Boolean = false;

    public async criarModalMedidaVariavel() {
        this.modalMedidaVariavel = await ModalService.createFromJson('faturamento/modal/modalMedidaVariavel', true);
    }

    public destruirModal() {
        this.modalMedidaVariavel?.destroy();
    }

    public async exibirModalFilter({ row }: any) {
        this.modalMedidaVariavel.show();
        this.currentRow = row;
        setTimeout(() => {
            this.popularModalMedidasVariaveis(row);
            this.popularModalGridMedidaVariavel(row);
        }, 800);
    }

    public async modalExibirFat() {
        this.modalExibirFaturamento = await ModalService.createFromJson('faturamento/modal/modalFaturamento', true);
        this.modalExibirFaturamento.show();
    }

    public fecharModalExibirFat() {
        this.modalExibirFaturamento.hide();
        this.modalExibirFaturamento?.destroy();
    }

    public onBeforeMountModal() {
        this.classModal = 'modalVariableMeasure';
    }

    public fecharModalFilter() {
        this.modalMedidaVariavel.hide();
    }

    public async exibirModaltituloHeader({ row }: any) {
        this.modalTituloHeader = await ModalService.createFromJson('faturamento/modal/modalTitulo', true);
        this.modalTituloHeader.show();
        this.currentRow = row;
    }

    public fecharModalTituloHeader() {
        this.modalTituloHeader.hide();
        this.modalTituloHeader?.destroy();
    }

    public controleVisibilidadeFrame(component: any, row: any) {
        if (row !== undefined && row.IDTIPO === 'P') {
            this.visibilidadeFrameGridPincipal = false;
            if (row.IDTPFATURA === 'P') {
                this.visibilidadeItensFrameItensValorFixo = false;
                this.visibilidadeItensFrameItensValorFixoParcela = true;
            } else {
                this.visibilidadeItensFrameItensValorFixo = true;
                this.visibilidadeItensFrameItensValorFixoParcela = false;
            }
            this.visibilidadeItensFrameItensValorVariavel = false;
            this.tituloHeader = this.formataTituloheader(row);
            this.setFiltroValorFixo(row);
        } else if (row !== undefined && row.IDTIPO === 'A') {
            this.visibilidadeFrameGridPincipal = false;
            this.visibilidadeItensFrameItensValorFixo = false;
            this.visibilidadeItensFrameItensValorFixoParcela = false;
            this.visibilidadeItensFrameItensValorVariavel = true;
            this.tituloHeader = this.formataTituloheader(row);
            this.setFiltroValorAgrupado(row);
        } else if (row !== undefined && row.IDTIPO === 'AME') {
            this.visibilidadeFrameGridPincipal = false;
            this.visibilidadeItensFrameItensValorFixo = false;
            this.visibilidadeItensFrameItensValorFixoParcela = false;
            this.visibilidadeItensFrameItensValorVariavel = true;
            this.tituloHeader = this.formataTituloheader(row);
            this.setFiltroValorAgrupadoEstimado(row);
        } else if (row !== undefined && row.IDTIPO === 'M') {
            this.visibilidadeFrameGridPincipal = false;
            this.visibilidadeItensFrameItensValorFixo = false;
            this.visibilidadeItensFrameItensValorFixoParcela = false;
            this.visibilidadeItensFrameItensValorVariavel = true;
            this.tituloHeader = this.formataTituloheader(row);
            this.setFiltroValorNaoAgrupado(row);
        }
        if (component.name === 'botaoVoltarGridFixo' || component.name === 'botaoVoltarGridVariavel') {
            this.vrNegociado = false;
            this.visibilidadeFrameGridPincipal = true;
            this.visibilidadeItensFrameItensValorFixo = false;
            this.visibilidadeItensFrameItensValorFixoParcela = false;
            this.visibilidadeItensFrameItensValorVariavel = false;
            this.tituloHeader = '';
            this.tituloHeaderCompleto = '';
            this.limparDatasourceGrids();
        }
    }

    public formataTituloheader(row: any) {
        let title = '';
        if (row.NRORCAMENTO !== undefined && row.NRORCAMENTO !== null) {
            this.tituloHeaderCompleto = `${row.NRORCAMENTO} ${row.DSREFERENCIACONT}`;
            if (row.NRORCAMENTO.length <= 20) {
                if (row.NRORCAMENTO.length + row.DSREFERENCIACONT.length > 70) {
                    const titleconcat = `${row.NRORCAMENTO} ${row.DSREFERENCIACONT}`;
                    title = `${titleconcat.substring(0, 70)} ...`;
                } else {
                    title = `${row.NRORCAMENTO} ${row.DSREFERENCIACONT}`;
                }
            } else if (row.NRORCAMENTO.length > 70) {
                title = `${row.NRORCAMENTO.substr(0, 70)} ...`;
            } else {
                title = row.NRORCAMENTO.substr(0, 70);
            }
        } else if (row.NRPROPOSTA !== undefined && row.NRPROPOSTA !== null) {
            this.tituloHeaderCompleto = `${row.NRPROPOSTA} ${row.DSREFERENCIACONT}`;
            if (row.NRPROPOSTA.length <= 20) {
                if (row.NRPROPOSTA.length + row.DSREFERENCIACONT.length > 70) {
                    const titleconcat = `${row.NRPROPOSTA} ${row.DSREFERENCIACONT}`;
                    title = `${titleconcat.substring(0, 70)} ...`;
                } else {
                    title = `${row.NRPROPOSTA} ${row.DSREFERENCIACONT}`;
                }
            } else if (row.NRPROPOSTA.length > 70) {
                title = `${row.NRPROPOSTA.substr(0, 70)} ...`;
            } else {
                title = row.NRPROPOSTA.substr(0, 70);
            }
        } else if (row.DSREFERENCIACONT !== undefined && row.DSREFERENCIACONT !== null) {
            this.tituloHeaderCompleto = row.DSREFERENCIACONT;

            if (row.DSREFERENCIACONT.length > 70) {
                title = `${row.DSREFERENCIACONT.substr(0, 70)} ...`;
            } else {
                title = row.DSREFERENCIACONT;
            }
        }
        return title;
    }

    public limparDatasourceGrids() {
        Metadata.getInstance<TekGrid>('gridItensValorFixo').datasource.data = [];
        Metadata.getInstance<TekGrid>('gridItensValorFixoParcela').datasource.data = [];
        Metadata.getInstance<TekGrid>('gridMedidasVariaveis').datasource.data = [];
    }

    public setFiltroValorFixo(row: any) {
        if (row.IDTPFATURA === 'P') {
            const grid = Metadata.getInstance<TekGrid>('gridItensValorFixoParcela');
            grid.datasource.setFilter({
                VRORIGINAL: row.VRORIGINAL,
                VRNEGCONTR: row.VRNEGCONTR,
                DTINICOMPET: row.DTINICOMPET,
                DTFINCOMPET: row.DTFINCOMPET,
                NRFATURACONT: row.NRFATURACONT,
                NRAGRUPAMENTO: row.NRAGRUPAMENTO,
            });

            const gridParc = Metadata.getInstance<TekGrid>('gridParcelas');
            gridParc.datasource.setFilter({
                NRSEQCONTRATO: row.NRSEQCONTRATO,
                NRFATURACONT: row.NRFATURACONT,
            });
        } else {
            const grid = Metadata.getInstance<TekGrid>('gridItensValorFixo');
            grid.datasource.setFilter({
                VRORIGINAL: row.VRORIGINAL,
                VRNEGCONTR: row.VRNEGCONTR,
                DTINICOMPET: row.DTINICOMPET,
                DTFINCOMPET: row.DTFINCOMPET,
                NRFATURACONT: row.NRFATURACONT,
                NRAGRUPAMENTO: row.NRAGRUPAMENTO,
            });
        }
    }

    public setFiltroValorAgrupado(row: any) {
        const grid = Metadata.getInstance<TekGrid>('gridItensValorVariavel');
        this.route = '/getItensValorAgrupado';
        grid.datasource.setFilter({
            VRORIGINAL: row.VRORIGINAL,
            VRNEGCONTR: row.VRNEGCONTR,
            DTINICOMPET: row.DTINICOMPET,
            DTFINCOMPET: row.DTFINCOMPET,
            NRFATURACONT: row.NRFATURACONT,
            NRAGRUPAMENTO: row.NRAGRUPAMENTO,
        });
    }

    public setFiltroValorNaoAgrupado(row: any) {
        const grid = Metadata.getInstance<TekTreeGrid>('gridItensValorVariavel');
        this.route = '/getItensValorNaoAgrupado';
        grid.datasource.setFilter({
            VRORIGINAL: row.VRORIGINAL,
            VRNEGCONTR: row.VRNEGCONTR,
            DTINICOMPET: row.DTINICOMPET,
            DTFINCOMPET: row.DTFINCOMPET,
            NRFATURACONT: row.NRFATURACONT,
            NRAGRUPAMENTO: row.NRAGRUPAMENTO,
        });
    }

    public setFiltroValorAgrupadoEstimado(row: any) {
        const grid = Metadata.getInstance<TekTreeGrid>('gridItensValorVariavel');
        this.route = '/getItensValorAgrupadoEstimado';
        grid.datasource.setFilter({
            NRPARCNEGOCIO: row.NRPARCFATURA,
            VRORIGINAL: row.VRORIGINAL,
            VRNEGCONTR: row.VRNEGCONTR,
            DTINICOMPET: row.DTINICOMPET,
            DTFINCOMPET: row.DTFINCOMPET,
            NRFATURACONT: row.NRFATURACONT,
            NRAGRUPAMENTO: row.NRAGRUPAMENTO,
        });
    }

    public getMedidasVariaveis({ row }: any) {
        if (row.tree__level !== 1 || (row.tree__level === 1 && row.tree__children.length === 0)) {
            const grid = Metadata.getInstance<TekGrid>('gridMedidasVariaveis');
            const conditions = [
                { columnName: 'NRPRODUTO_ID', operator: '=', value: (row.IDELEMENTO !== null) ? row.IDELEMENTO : null },
                { columnName: 'CDSERVORCA', operator: '=', value: row.CDSERVORCA },
                { columnName: 'initCompetence', operator: '=', value: row.DTINICOMPET },
                { columnName: 'endCompetence', operator: '=', value: row.DTFINCOMPET },
                { columnName: 'contractId', operator: '=', value: row.NRSEQCONTRATO },
                { columnName: 'qtFatura', operator: '=', value: row.QTCONSIDERADA },
            ];
            grid.datasource.setFilter(conditions);
        }
    }

    public rowStyleConditions(row: any) {
        switch (row.IDSITUACAO) {
            case 'ATRASO':
                return { cssClass: 'linhaGridVermelha' };
            case 'PLANEJADO':
                return { cssClass: 'linhaGridAzul' };
            case 'PENDENTE':
                return { cssClass: 'linhaGridAmarelo' };
            case 'FATURADA':
                return { cssClass: 'linhaGridVerde' };
            case 'RECEBIDO':
                return { cssClass: 'zh-inactive-important' };
            default:
                return undefined;
        }
    }

    public rowStyleConditionsParcela(row: any) {
        if (`${'P'}${row.NRFATURACONT}` === row.NRFATURACONTPAI) {
          return { cssClass: 'boldParcela' };
        }
        return undefined;
    }

    public visibilidadeVrNegociado({ row }: any) {
        if (this.vrNegociado) {
            return;
        }
        if (row.VRNEGCONTR !== undefined && row.VRNEGCONTR !== null && row.VRNEGCONTR !== '0') {
            this.vrNegociado = true;
        }
    }

    public popularModalFaturamento({ component }: any) {
        let faturamento = '';
        component.children[3].text = this.currentRow.DTINICOMPET;
        component.children[4].text = this.currentRow.DTFINCOMPET;
        component.children[5].text = this.currentRow.DTVENCIMENTO;
        component.children[10].text = this.currentRow.VRATUAREC;
        component.children[11].text = this.currentRow.NRNOTAFISC;
        component.children[13].text = this.currentRow.VRVENCIMENTO;
        switch (this.currentRow.IDSITUACAO) {
            case 'FATURADA':
                faturamento = 'Faturado (Em aberto) - com nota fiscal emitida, boleto ainda não vencido';
                break;
            case 'PENDENTE':
                faturamento = 'Pendente - Com a coleta da medição, com geração das parcelas, sem nota fiscal';
                break;
            case 'PLANEJADO':
                faturamento = 'Faturado (Pendente de conferência) - com nota fiscal emitida, pagamento de boleto aguardando conferência';
                break;
            case 'ATRASO':
                faturamento = 'Faturado (Em atraso) - com nota fiscal emitida, boleto vencido';
                break;
            case 'ESTIMADO':
                faturamento = 'Estimado - Com a coleta da medição, sem geração das parcelas';
                break;
            case 'RECEBIDO':
                faturamento = 'Recebido - boleto pago';
                break;
            default:
                faturamento = '';
                break;
        }
        component.children[9].text = faturamento;
    }

    public visibilidadeBotao({ row }: any) {
        if (row.IDSITUACAO === 'FATURADA' || row.IDSITUACAO === 'ATRASO') {
            return true;
        }
        return false;
    }

    public imprimirBoleto(row: any) {
        LoadingService.show();
        Http.post('/findBilletIssuedFct', {
            NR: row.NRLANCTONF,
        }).then((response) => {
            const retorno = response.data.URL_REPORT;
            if (retorno.length) {
                window.open(retorno);
            } else {
                Utilities.showDialog('Atenção!', 'warning', 'O boleto ainda não foi gerado.');
            }
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }

    public popularModalMedidasVariaveis(row: any) {
        Metadata.getInstance<Text>('medidaVariavelText').text = row.measureName;
        Metadata.getInstance<Text>('qtdMinimaText').text = row.countMin;
        Metadata.getInstance<Text>('qtdfaturaText').text = row.qtFatura;
        Metadata.getInstance<Text>('qtdFaturamentoText').text = row.count;
        Metadata.getInstance<Text>('dataColetaText').text = row.date;
        Metadata.getInstance<Text>('inicioVigenciaText').text = row.initCompetence;
        Metadata.getInstance<Text>('finalVigenciaText').text = row.endCompetence;
    }

    public popularModalGridMedidaVariavel(row: any) {
        const grid = Metadata.getInstance<TekGrid>('gridDadosColetados');
        this.modularGridmodal(row.log, grid);
        grid.datasource.updateData(row.log);
    }

    public modularGridmodal(row: any, grid: any) {
        if (row[0] !== undefined) {
            const rows = row[0];
            grid.columns = Object.keys(rows).map((key) => new TekGridColumn({ name: key, label: key }, grid));
        }
    }

    public clickGrid({ component, row }: any) {
        if (this.verificar) {
            this.verificar = false;
            if (row !== undefined) {
                this.currentRow = row;
            }
            if (component.name === 'gridFaturamento' || component.name === 'botaoVoltarGridFixo' || component.name === 'botaoVoltarGridVariavel') {
                if (this.currentRow.NRCONTRATOFCT !== undefined && this.currentRow.NRCONTRATOFCT.length < 5) {
                    this.modalExibirFat();
                } else {
                    this.controleVisibilidadeFrame(component, row);
                }
            } else {
                this.imprimirBoleto(row);
            }
            setTimeout(() => {
                this.verificar = true;
            }, 500);
        }
    }

    public setFiltro({ component }: any) {
        component.datasource.dynamicFilter = {
            IDSITUACAO: [{
                relation: 'AND',
                operation: 'IN',
                value: ['FATURADA', 'PENDENTE', 'PLANEJADO', 'ATRASO', 'ESTIMADO'],
            }],
        };
        component.datasource.get();
    }

    public dataDaColeta({ row }: any) {
        const grid = Metadata.getInstance<TekGrid>('gridMedidasVariaveis');
        if (row.date === undefined) {
            grid.columns[2].isVisible = false;
            grid.columns[5].isVisible = false;
            return [];
        }
        grid.columns[2].isVisible = true;
        grid.columns[5].isVisible = true;
        return [];
    }
}
